<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 5.9: Pointers vs. Multi-dimensional Arrays</title>
<link href="sx8h.html" rev=precedes>
<link href="sx8j.html" rel=precedes>
<link href="sx8.html" rev=subdocument>
</head>
<body>
<H2>section 5.9: Pointers vs. Multi-dimensional Arrays</H2>

<p>Actually, some people
(and not just newcomers)
are sometimes
confused about the difference
between a one-dimensional array and a single pointer,
too;
moving to two-dimensional arrays, arrays of pointers,
and pointers to pointers only makes things worse.
(But don't lose heart:
if you pay attention and keep your head screwed on straight,
you should be able to keep the differences clearly in mind.)
</p><p>The adjective ``syntactically'' in the paragraph at the bottom of 
the page is significant:
after saying
<pre>	int *b[10];
</pre>an immediate reference to <TT>b[3][4]</TT>
would <em>not</em> be completely legal.
It wouldn't be a syntax error or anything,
but when the compiler tried to fetch the third pointer
and then the fourth integer pointed to,
it would go off into deep space,
because there <em>isn't</em> a third pointer
yet
and it doesn't point anywhere.
</p><p>You might want to draw a picture of the data structures that would result
``[a]ssuming that each element of <TT>b</TT>
does point to a twenty-element array,''
and verify that there are ``200 <TT>int</TT>s set aside,
plus ten cells for the pointers.''
(The picture will be similar to the one on the next page.)
</p><p>Actually, I'm not sure if having rows of different lengths
is the only important advantage of using a pointer array.
Another is that the size of the arrays
(as we'll see later)
can be decided at run-time;
another is that the pointers make certain manipulations easier
(such as the sorting example we worked through in section 5.6).
</p><p>page 114
</p><p>Do study the pictures on this page carefully,
and make sure you understand
the representations of the <TT>name</TT> and <TT>aname</TT> arrays
and how they differ.
(You might want to refer back
to the similar discussion of <TT>pmessage</TT> and <TT>amessage</TT>
on page 104 in section 5.5.)
</p><hr>
<p>
Read sequentially:
<a href="sx8h.html" rev=precedes>prev</a>
<a href="sx8j.html" rel=precedes>next</a>
<a href="sx8.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
